package com.loafle.overflow.container.general;

import com.loafle.overflow.container.Container;
import com.loafle.overflow.container.configuration.ContainerConfiguration;
import com.loafle.overflow.container.general.client.GeneralContainerClient;
import com.loafle.overflow.container.general.client.GeneralContainerConfiguration;

import org.springframework.context.annotation.AnnotationConfigApplicationContext;

public class GeneralContainer {

  public static void main(String[] args) throws Exception {
    if (args.length <= 0) {
      System.out.println("first parameter is path of pid file");
      return;
    }
    String pidFilePath = args[0];

    try (AnnotationConfigApplicationContext context = new AnnotationConfigApplicationContext()) {
      context.getBeanFactory().registerSingleton(Container.PORT_NUMBER, pidFilePath);
      context.register(GeneralContainerConfiguration.class, ContainerConfiguration.class);
      context.refresh();
      context.registerShutdownHook();
      GeneralContainerClient client = context.getBean(GeneralContainerClient.class);
      Runtime.getRuntime().addShutdownHook(new Thread() {
        @Override
        public void run() {
          try {
            client.stop();
          } catch (Exception e) {
            e.printStackTrace();
          }
        }
      });
      client.start();
    }
  }
}
